diff --git a/pbrd/pbr_map.c b/pbrd/pbr_map.c
index 6b81e1058e42..f2402c613d1c 100644
--- a/pbrd/pbr_map.c
+++ b/pbrd/pbr_map.c
@@ -357,6 +357,9 @@ extern void pbr_map_delete(struct pbr_map_sequence *pbrms)
 	if (pbrms->nhg)
 		pbr_nht_delete_individual_nexthop(pbrms);
 
+    XFREE(MTYPE_TMP, pbrms->nhgrp_name);
+    prefix_free(&pbrms->dst);
+
 	listnode_delete(pbrm->seqnumbers, pbrms);
 
 	if (pbrm->seqnumbers->count == 0) {
